=== debian/changelog ===
darktable (1.1.3-1ubuntu1) raring; urgency=low

  * Added fix_ftbfs_glib2.35.4 to resolve FTBFS.

 -- Daniel T Chen <crimsun@ubuntu.com>  Sat, 16 Feb 2013 08:05:16 -0500

darktable (1.1.3-1) unstable; urgency=low

  * New upstream camera support update and bugfix release:
    - Check for glib 2.28 at config time.
    - Don't sanitize exif when creating HDR DNGs
    - Colorpicker now disappears immediately when disabling it
    - Lens correction now uses loose lens matching (Ivan Tarozzi)
    - Konica Minolta Dynax 5D rotation fix
    - Removed an outdated assertion which could cause a crash in rare cases
    - Fix crash when loading half-corrupted XMPs
    - Fix crash when an imported file contains incomplete GPS information
    - libjpeg-turbo workaround (Klaus Post)
    - Preliminary support for nikon d5200
    - White balance preset updates:
      - Sony Alpha 700 (update to firmware v4)
      - Sony Alpha 230 (new)
      - Canon EOS 650d (new)
      - Canon EOS Rebel T2i (fixed)
      - Canon EOS M (fixed)
    - Enhanced color rendition:
      - Konica Minolta Dynax 5D (Wolfgang Kuehnel)
      - Sony NEX 3 (Wolfgang Kuehnel)
      - Sony Alpha 230 (Wolfgang Kuehnel)
      - Sony RX100 (Josef Wells)

 -- David Bremner <bremner@debian.org>  Sat, 09 Feb 2013 11:25:40 -0400

darktable (1.1.2-1) unstable; urgency=low

  * New upstream camera support update and bugfix release:
    - fix export resolution rounding issue
    - correctly set output dimension in exif instead of passing the raw
      resolution verbatim
    - local average green eq was fixed
    - use ordered arrays in xmp files
    - disable export parallelism for flickr/picasa export
    - don't enter tethering mode when there is no camera attached
    - bring back the pin for map thumbnails
    - improved tiff support
    - vignetting now has a dithering option
    - read nikon subject distance properly
    - assorted freebsd fixes
    - various opencl fixes
    - usermanual updates
  * Support for the following camera's added or updated:
    - canon eos 6d, powershot s110, powershot g15, powershot sx50 hs
    - nikon 1 v2, d600, coolpix p7700
    - olympus e pl5, e pm2, xz 2
    - panasonic dmc gh3, dmc lx7
    - pentax k5ii,  ex2f
    - sony rx1, nex 6, slt a99
    - sony nex c3 blackpoint/greenshift fix
  * white balance preset updates:
    - canon eos 550d, 5d mark iii
    - olympus xz 1
    - sony nex c3, slt a57, nex 5n
    - panasonic dmc-gh3

 -- David Bremner <bremner@debian.org>  Sat, 12 Jan 2013 09:15:30 -0400

darktable (1.1.1-1) unstable; urgency=low

  * New upstream release (1.1); Many new features and bug fixes.
    - geotagging
    - image similarity search
    - improved sharpness and noise reduction
    - improved color management
    For more details see:
    http://www.darktable.org/2012/11/released-darktable-1-1/
  * Bug fix release (1.1.1)
    - a curve related crash was fixed (Upstream: #9906)
    - a deadlock in the lens correction module was fixed (Upstream: #9106)
    For more details see: http://www.darktable.org/2012/12/released-1-1-1/
  * Add versioned Build-Depends on debhelper
  * Enable hardening flags.

 -- David Bremner <bremner@debian.org>  Tue, 11 Dec 2012 17:39:11 -0400
